--;===========================================================
--; DEBUG HOTKEYS
--;===========================================================
--key, ctrl, alt, shift, pause, debug key, function

local speedMul = 1
local speedAdd = 0
function changeSpeed(add)
	if add ~= nil then
		speedAdd = speedAdd + add / 100
	elseif speedMul >= 4 then
		speedMul = 0.25
	else
		speedMul = speedMul * 2
	end
	setAccel(math.max(0.01, speedMul + speedAdd))
end

function toggleAI(p)
	local oldid = id()
	if player(p) then
		if ailevel() > 0 then
			setAILevel(0)
		else
			setAILevel(config.Difficulty)
		end
		playerid(oldid)
	end
end

function kill(p, ...)
	local oldid = id()
	if player(p) then
		local n = ...
		if not n then n = 0 end
		setLife(n)
		playerid(oldid)
	end
end

function powMax(p)
	local oldid = id()
	if player(p) then
		setPower(powermax())
		setGuardPoints(guardpointsmax())
		setDizzyPoints(dizzypointsmax())
		playerid(oldid)
	end
end

function full(p)
	local oldid = id()
	if player(p) then
		setLife(lifemax())
		setPower(powermax())
		setGuardPoints(guardpointsmax())
		setDizzyPoints(dizzypointsmax())
		setRedLife(0)
		removeDizzy()
		playerid(oldid)
	end
end

function stand(p)
	local oldid = id()
	if player(p) then
		selfState(0)
		playerid(oldid)
	end
end

function debugFlag(side)
	if start ~= nil and start.t_savedData.debugFlag ~= nil then
		start.t_savedData.debugflag[side] = true
	end
end

--;===========================================================
--; DEBUG STATUS INFO
--;===========================================================
function statusInfo(p)
	local oldid = id()
	if not player(p) then return false end
	local ret = string.format(
		'P%d: %d; LIF:%4d; POW:%4d; ATK:%4d; DEF:%4d; RED:%4d; GRD:%4d; STN:%4d',
		playerno(), id(), life(), power(), attack(), defence(), redlife(), guardpoints(), dizzypoints()
	)
	playerid(oldid)
	return ret
end

loadDebugStatus('statusInfo')

--;===========================================================
--; DEBUG PLAYER/HELPER INFO
--;===========================================================
function customState()
	if not incustomstate() then return "" end
	return " (in " .. stateownername() .. " " .. stateownerid() .. "'s state)"
end

function boolToInt(bool)
	if bool then return 1 end
	return 0
end

function engineInfo()
	return string.format('VSync: %d; Speed: %d/%d%%', vsync(), gameLogicSpeed(), gamespeed())
end

function playerInfo()
	return string.format('%s %d%s', name(), id(), customState())
end

function actionInfo()
	return string.format(
		'ActionID: %d (P%d); SPR: %d,%d; ElemNo: %d/%d; Time: %d/%d (%d/%d)',
		anim(), animowner(), spritegroup(), spritenumber(), animelemno(0), animelemcount(), animelemtimesum(), animelemlength(), animtimesum(), animlength()
	)
end

function stateInfo()
	return string.format(
		'State No: %d (P%d); CTRL: %s; Type: %s; MoveType: %s; Physics: %s; Time: %d',
		stateno(), stateowner(), boolToInt(ctrl()), statetype(), movetype(), physics(), time()-1
	)
end

loadDebugInfo({'engineInfo', 'playerInfo', 'actionInfo', 'stateInfo'})

--;===========================================================
--; MATCH LOOP
--;===========================================================
local endFlag = false
local sf=false
--function called during match via config.json CommonLua
function loop()
	if start == nil then --match started via command line without -loadmotif flag
		if esc() then
			endMatch()
			os.exit()
		end
		if indialogue() then
			dialogueReset()
		end
		togglePostMatch(false)
		toggleDialogueBars(false)
		return
	end
	--credits
	if main.credits ~= -1 and getKey(motif.attract_mode.credits_key) then
		sndPlay(motif.files.snd_data, motif.attract_mode.credits_snd[1], motif.attract_mode.credits_snd[2])
		main.credits = main.credits + 1
		resetKey()
	end

	--if you run out of characters, game over.
	 if player(1) and map("tl")==1  and stateno()==5150 and time()==111  and sf==false then
	 	 
	 if e1 ~=nil then

    if e1.tl<4 then	
	e1.tl = e1.tl+1
	
	else
		main.continueScreen = false
		 e1.cs=false
		 	sf=true
	 end
       print(e1.tl)

	end
	end
	--fadout doesnt work if speed is lower than 1
	if extra.CombatMode ~= nil and extra.CombatMode then
	if roundstate()>2 then
	setGameSpeed(1)
	else
	setGameSpeed(.85)
	end
	end
	--music
	start.f_stageMusic()
	--match start
	if roundstart() then
		setLifebarElements({bars = main.lifebar.bars})
		if roundno() == 1 then
			speedMul = 1
			speedAdd = 0
			start.victoryInit = false
			start.resultInit = false
			start.continueInit = false
			start.hiscoreInit = false
			endFlag = false
			if indialogue() then
				dialogueReset()
			end
			if gamemode('training') then
				menu.f_trainingReset()
			end
			
			if (gamemode('versus') or gamemode('training'))  and extra.CombatMode then
		
			local mu ={"dm","wp","tp","c","xp"}
			local gs = mu[math.random(#mu)]
				print('song '..gs)
			main.f_playBGM(true, 'sound/'..gs..'.ogg', 1, 255, 0, -1)
			end
		end
		start.turnsRecoveryInit = false
		start.rankInit = false
		start.dialogueInit = false
	end
	--dialogue
	if indialogue() then
		start.f_dialogue()
	--match end
	elseif roundstate() == -1 then
		if not endFlag then
			resetMatchData(false)
			endFlag = true
		end
		--victory screen
		if start.f_victory() then
			return
		--result screen
		elseif start.f_result() then
			return
		--continue screen
		elseif start.f_continue() then
			return
		end
	clearColor(motif.selectbgdef.bgclearcolor[1], motif.selectbgdef.bgclearcolor[2], motif.selectbgdef.bgclearcolor[3])
		togglePostMatch(false)
	end
	if winnerteam() ~= -1 and player(winnerteam()) and roundstate() == 4 then
		--turns life recovery
		start.f_turnsRecovery()
		--rank
		start.f_rank()
	end
	--pause menu
	if main.pauseMenu then
		playerBufReset()
		menu.f_run()
	else
		main.f_cmdInput()
		--esc / m
		if (esc() or (main.f_input(main.t_players, {'m'})) and not network()) and not start.challengerInit then
			if network() or gamemode('demo') or gamemode('randomtest') or (not config.EscOpensMenu and esc()) then
				endMatch()
				fought = {}
			else
				menu.f_init()
			end
		--demo mode
		elseif gamemode('demo') and ((motif.attract_mode.enabled == 1 and main.credits > 0 and not sndPlaying(motif.files.snd_data, motif.attract_mode.credits_snd[1], motif.attract_mode.credits_snd[2])) or (motif.attract_mode.enabled == 0 and main.f_input(main.t_players, {'pal'})) or gametime() >= motif.demo_mode.fight_endtime) then
			endMatch()
		--challenger
		elseif gamemode('arcade') then
			if start.challenger > 0 then
				start.f_challenger()
			else
				-- TODO: detecting players that are part of P1 team
				-- [[for i = 1, #main.t_cmd do
					-- if commandGetState(main.t_cmd[i], '/s') then
						-- print(i)
					-- end
				-- end]]
				if main.f_input(main.t_players, {'s'}) and main.playerInput ~= 1 and (motif.attract_mode.enabled == 0 or main.credits ~= 0) then
					start.challenger = main.playerInput
				end
			end
		end
	end
end
